<template>
  <NuxtLayout :name="'dashboard'">
    <div class="flex justify-evenly container p-8">
      <div class="p-2 my-12 rounded-lg lg:w-1/3 xl:1/2 h-fit border-solid border-slate-300 border-2">
        <!-- <DynamicForm :fields="fields" :formTitle="formTitle" :submitName="submitName" :onSubmit="onSubmit" /> -->
        <form class="p-2" @submit.prevent="onSubmit">
          <h2 class="w-full text-center mb-4 text-xl font-semibold">
            {{ formTitle }}
          </h2>
          <div class="mb-4">
            <label for="title" class="block text-sm font-medium text-gray-700">Title</label>
            <input type="text" id="title" name="title" v-model="form.title"
              class="w-full px-4 py-2 border rounded-lg focus:outline-none focus:ring focus:border-blue-300"
              :placeholder="`Enter your Document's Title`" />
          </div>
          <div class="mb-4">
            <label for="description" class="block text-sm font-medium text-gray-700">Description</label>
            <input type="text" id="description" name="description" v-model="form.description"
              class="w-full px-4 py-2 border rounded-lg focus:outline-none focus:ring focus:border-blue-300"
              :placeholder="`Enter your Document`" />
          </div>
          <div class="mb-4">
            <label for="file" class="block text-sm font-medium text-gray-700">Document</label>
            <input type="file" id="file" name="file" @change="onFileChange" accept=".pdf"
              class="w-full px-4 py-2 border rounded-lg focus:outline-none focus:ring focus:border-blue-300"
              :placeholder="`Enter your Document's File`" />
          </div>
          <button type="submit"
            class="w-full py-2 px-4 mt-4 bg-blue-500 text-white rounded-lg hover:bg-blue-600 active:bg-blue-900">
            <span v-if="isLoading">
              <Icon name="eos-icons:bubble-loading" class="w-5 h-5" />
              {{ submitName }}
            </span>
            <span v-else>
              <Icon name="ic:round-search" class="w-5 h-5" />
              {{ submitName }}
            </span>
          </button>
        </form>
      </div>
    </div>
  </NuxtLayout>
</template>

<script lang="ts">

definePageMeta({
  middleware: ["auth"],
});

export default {
  data() {
    return {
      formTitle: "Upload PDF Baru",
      submitName: "Save",
      isLoading: false,
      form: {
        title: '',
        description: '',
        file: null as File | null,
      },
      fileInputRef: null as HTMLInputElement | null,
    };
  },
  methods: {
    onSubmit() {
      this.isLoading = true;
      const toastStore = useToastStore();
      const accessToken: string = localStorage.getItem("access_token")!;
      const title = this.form.title;
      const description = this.form.description;

      if (!this.form.file) {
        toastStore.showToast('No file selected', 'danger');
        this.isLoading = false;
        return;
      }
      const formData = new FormData();
      formData.append('file', this.form.file);

      this.$api
        .post(`/file?title=${title}&description=${description}`,
          formData,
          {
            headers: {
              'Accept': 'application/json',
              'Authorization': `Bearer ${accessToken}`,
              'Content-Type': 'multipart/form-data',
            },
          }
        )
        .then((response) => {
          console.log(response);
          toastStore.showToast('success', "Data stored successfully");
          this.$router.replace("/files");
        })
        .catch((error) => {
          console.log(error);
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          toastStore.showToast(message, 'danger');
        }).finally(() => {
          this.isLoading = false;
        })
    },
    onFileChange(event: Event) {
      const input = event.target as HTMLInputElement
      if (input.files && input.files.length > 0) {
        this.form.file = input.files[0]
      } else {
        this.form.file = null
      }
    },
  },
};
</script>
